/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-1.aml, Fri Jun  2 21:48:28 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000003D0 (976)
 *     Revision         0x01
 *     Checksum         0xAB
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "CB-01   "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120711 (538052369)
 */
DefinitionBlock ("", "SSDT", 1, "LENOVO", "CB-01   ", 0x00001000)
{
    /*
     * External declarations were imported from
     * a reference file -- refs.txt
     */

    External (_GPE.MMTB, MethodObj)    // Imported: 0 Arguments
    External (_GPE.VHOV, MethodObj)    // Imported: 3 Arguments
    External (_SB_.PCI0.GFX0.DD02._BCM, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECMD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.SAT0.SDSM, MethodObj)    // Imported: 4 Arguments
    External (_SB_.PCI0.XHC_.RHUB.TPLD, MethodObj)    // Imported: 2 Arguments
    External (MDBG, MethodObj)    // Imported: 1 Arguments

    Scope (\)
    {
        OperationRegion (ONVS, SystemMemory, 0xBCF7ED98, 0x00EC)
        Field (ONVS, AnyAcc, Lock, Preserve)
        {
            WMIF,   32, 
            PS2V,   8, 
            KBID,   8, 
            KBSZ,   8, 
            OBID,   8, 
            EDID,   1024, 
            GPBA,   32, 
            LFCO,   768
        }

        OperationRegion (LSEP, SystemIO, 0xB2, 0x02)
        Field (LSEP, WordAcc, NoLock, Preserve)
        {
            LSMI,   8
        }
    }

    Scope (\_SB)
    {
        Device (LSE1)
        {
            Name (_HID, "PNP0C14")  // _HID: Hardware ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (_WDG, Buffer (0x28)
            {
                /* 0000 */  0xAA, 0xA8, 0x31, 0x5D, 0x09, 0x11, 0x0F, 0x4D,
                /* 0008 */  0x83, 0x20, 0x6F, 0x29, 0x69, 0xDF, 0x8B, 0x38,
                /* 0010 */  0x41, 0x41, 0x01, 0x02, 0x21, 0x12, 0x90, 0x05,
                /* 0018 */  0x66, 0xD5, 0xD1, 0x11, 0xB2, 0xF0, 0x00, 0xA0,
                /* 0020 */  0xC9, 0x06, 0x29, 0x10, 0x44, 0x44, 0x01, 0x00 
            })
            Method (WMAA, 3, NotSerialized)
            {
                If (LEqual (Arg1, One))
                {
                    Return (WMIF)
                }

                If (LEqual (Arg1, 0x02))
                {
                    ToInteger (Arg2, Local0)
                    Store (Local0, WMIF)
                    Store (0xDD, LSMI)
                    Return (Zero)
                }
            }

            Name (WQDD, Buffer (0x02C5)
            {
                /* 0000 */  0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00,
                /* 0008 */  0xB5, 0x02, 0x00, 0x00, 0x18, 0x08, 0x00, 0x00,
                /* 0010 */  0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54,
                /* 0018 */  0x18, 0xD5, 0x83, 0x00, 0x01, 0x06, 0x18, 0x42,
                /* 0020 */  0x20, 0x02, 0x02, 0x89, 0xC0, 0xC2, 0x69, 0x24,
                /* 0028 */  0xC9, 0x01, 0x0C, 0x46, 0x03, 0x88, 0xE4, 0x40,
                /* 0030 */  0xC8, 0x05, 0x13, 0x13, 0x20, 0x02, 0x42, 0x5E,
                /* 0038 */  0x05, 0xD8, 0x14, 0x60, 0x12, 0x44, 0xFD, 0xFB,
                /* 0040 */  0xC3, 0x0A, 0x0E, 0x25, 0x04, 0x42, 0x12, 0x05,
                /* 0048 */  0x98, 0x17, 0xA0, 0x5B, 0x80, 0x61, 0x01, 0xB6,
                /* 0050 */  0x05, 0x98, 0x16, 0xE0, 0x18, 0x92, 0x4A, 0x03,
                /* 0058 */  0xA7, 0x04, 0x96, 0x02, 0x21, 0xA1, 0x02, 0x94,
                /* 0060 */  0x0B, 0xF0, 0x2D, 0x40, 0x3B, 0xA2, 0x24, 0x0B,
                /* 0068 */  0xB0, 0x0C, 0x23, 0x02, 0x8F, 0x22, 0xB2, 0xD1,
                /* 0070 */  0x38, 0x34, 0x76, 0x18, 0x96, 0x09, 0xA6, 0x41,
                /* 0078 */  0x1C, 0x46, 0xD9, 0xC8, 0x22, 0xF0, 0x84, 0x3A,
                /* 0080 */  0x15, 0x20, 0x57, 0x80, 0x30, 0x01, 0xE2, 0x51,
                /* 0088 */  0x85, 0xD1, 0x1C, 0x14, 0x91, 0x0A, 0x8D, 0x12,
                /* 0090 */  0x33, 0x26, 0x02, 0xDB, 0x39, 0xB6, 0x46, 0x71,
                /* 0098 */  0x1A, 0x85, 0x0B, 0x90, 0x8E, 0xA1, 0x11, 0x1C,
                /* 00A0 */  0xD7, 0x31, 0xD8, 0xA2, 0x00, 0x9D, 0x02, 0x7C,
                /* 00A8 */  0x0A, 0xD0, 0x0A, 0x21, 0xBF, 0x38, 0x9A, 0x42,
                /* 00B0 */  0xA0, 0x20, 0x71, 0x1B, 0x9C, 0x80, 0x20, 0x0A,
                /* 00B8 */  0x42, 0xD6, 0x4C, 0x4E, 0x25, 0x7A, 0x84, 0x04,
                /* 00C0 */  0x51, 0x8E, 0x02, 0x23, 0x03, 0x42, 0x9E, 0x05,
                /* 00C8 */  0x58, 0x1F, 0x1E, 0x21, 0xB0, 0x7B, 0x01, 0xD6,
                /* 00D0 */  0xB0, 0xE5, 0x4C, 0x80, 0x31, 0x6C, 0x89, 0x83,
                /* 00D8 */  0x10, 0x42, 0x5B, 0x30, 0x42, 0x38, 0x28, 0xA3,
                /* 00E0 */  0x1C, 0x56, 0xCC, 0x28, 0x35, 0xA3, 0x08, 0x2E,
                /* 00E8 */  0x64, 0x65, 0x30, 0x42, 0xA9, 0x4D, 0x80, 0x46,
                /* 00F0 */  0x14, 0xE1, 0x05, 0x09, 0x11, 0x3D, 0x4C, 0xB4,
                /* 00F8 */  0x0A, 0xE1, 0x84, 0xD1, 0xFE, 0x20, 0x48, 0xB4,
                /* 0100 */  0xC3, 0x80, 0x24, 0x80, 0x28, 0xD2, 0x68, 0x50,
                /* 0108 */  0x07, 0x80, 0x04, 0x0F, 0x04, 0x3E, 0x0C, 0x9C,
                /* 0110 */  0xDE, 0x41, 0x1D, 0xE1, 0x61, 0x05, 0x39, 0xB0,
                /* 0118 */  0xC3, 0x3C, 0xC0, 0x27, 0x01, 0x8F, 0x99, 0x61,
                /* 0120 */  0x25, 0xF8, 0x39, 0xF0, 0xD1, 0x00, 0xEF, 0x1A,
                /* 0128 */  0x50, 0x77, 0x82, 0x27, 0x02, 0x36, 0xCB, 0x70,
                /* 0130 */  0x98, 0xFF, 0xFF, 0x10, 0x3D, 0xEA, 0x70, 0x27,
                /* 0138 */  0x70, 0x88, 0x0C, 0xD0, 0xF3, 0x7A, 0x18, 0xC0,
                /* 0140 */  0x3A, 0x9C, 0x8C, 0x4E, 0x02, 0x07, 0xDD, 0xEC,
                /* 0148 */  0xA9, 0x40, 0xF3, 0x4E, 0x70, 0x3C, 0x3E, 0x02,
                /* 0150 */  0x78, 0x3E, 0x27, 0x9C, 0xC0, 0xF2, 0x07, 0x81,
                /* 0158 */  0x1A, 0x99, 0xA1, 0x3D, 0xE0, 0xD3, 0x7A, 0x13,
                /* 0160 */  0xF0, 0x01, 0xE1, 0xB0, 0x98, 0x58, 0x08, 0x29,
                /* 0168 */  0x80, 0xD0, 0x78, 0xC0, 0xAF, 0xF8, 0x78, 0x20,
                /* 0170 */  0x84, 0xD7, 0x05, 0xCF, 0xD7, 0xC7, 0x04, 0x03,
                /* 0178 */  0x63, 0x07, 0xE4, 0x03, 0x42, 0x84, 0xE0, 0xCF,
                /* 0180 */  0x08, 0x47, 0xF4, 0x8E, 0x10, 0xE1, 0x49, 0x01,
                /* 0188 */  0x3E, 0x41, 0x91, 0x67, 0x07, 0xF4, 0x08, 0x38,
                /* 0190 */  0x74, 0xBC, 0xE3, 0x09, 0x1B, 0xF8, 0x78, 0xA2,
                /* 0198 */  0x9C, 0xC4, 0x01, 0xF9, 0x28, 0x11, 0xA1, 0x2E,
                /* 01A0 */  0x08, 0x9D, 0x2B, 0x8C, 0x70, 0xA2, 0x51, 0x7A,
                /* 01A8 */  0xBF, 0x5B, 0x10, 0x02, 0x87, 0x78, 0x1C, 0x68,
                /* 01B0 */  0xA4, 0x16, 0x48, 0x21, 0x1B, 0x4B, 0xF5, 0xE1,
                /* 01B8 */  0x82, 0x9F, 0x11, 0xE4, 0x71, 0x72, 0xC2, 0x7D,
                /* 01C0 */  0x53, 0x78, 0x87, 0xF0, 0xEC, 0x2D, 0x0F, 0x4A,
                /* 01C8 */  0x87, 0x11, 0x2E, 0x8C, 0x42, 0xB2, 0x20, 0x34,
                /* 01D0 */  0x1C, 0x43, 0x13, 0x38, 0x0A, 0xE2, 0x41, 0x38,
                /* 01D8 */  0x24, 0x84, 0x9C, 0x1C, 0x04, 0x50, 0xC3, 0xF7,
                /* 01E0 */  0xFC, 0x0E, 0xE1, 0x85, 0xC1, 0x04, 0x0E, 0x05,
                /* 01E8 */  0xA1, 0xB3, 0x83, 0x4F, 0x0B, 0xF8, 0x81, 0x3D,
                /* 01F0 */  0x58, 0x3C, 0x34, 0x78, 0x16, 0x3E, 0x46, 0x3C,
                /* 01F8 */  0x74, 0xC0, 0xFA, 0xFF, 0x1F, 0x3A, 0xF0, 0x43,
                /* 0200 */  0xC3, 0x8F, 0xC2, 0x1F, 0x16, 0x3A, 0x00, 0x72,
                /* 0208 */  0x27, 0x78, 0x19, 0x30, 0x01, 0x3B, 0x1B, 0xC0,
                /* 0210 */  0xBF, 0x77, 0x78, 0x14, 0xE7, 0xF0, 0xB2, 0x61,
                /* 0218 */  0x02, 0x0B, 0x3C, 0x1B, 0x80, 0x02, 0xC8, 0x77,
                /* 0220 */  0x01, 0x2B, 0x3D, 0x0F, 0xD0, 0x39, 0x84, 0x08,
                /* 0228 */  0x13, 0xCD, 0xF0, 0x98, 0xC0, 0x10, 0xB2, 0x00,
                /* 0230 */  0x21, 0x59, 0xE3, 0x42, 0x8D, 0xD2, 0xC7, 0x17,
                /* 0238 */  0x86, 0x7D, 0x82, 0x16, 0x3D, 0x48, 0xDD, 0x22,
                /* 0240 */  0x0E, 0xEA, 0x35, 0xC2, 0x67, 0x00, 0xC3, 0x7A,
                /* 0248 */  0xDC, 0x1C, 0xD6, 0x68, 0x61, 0x0F, 0xF7, 0x11,
                /* 0250 */  0xC2, 0xD7, 0x0F, 0xCF, 0xCC, 0x18, 0x61, 0x7D,
                /* 0258 */  0xF0, 0x00, 0x07, 0x20, 0xFE, 0xC2, 0xF0, 0x06,
                /* 0260 */  0xE0, 0x09, 0x18, 0x90, 0x0D, 0x15, 0x77, 0x16,
                /* 0268 */  0x80, 0x6B, 0xF5, 0x8A, 0x43, 0x6E, 0x20, 0x9E,
                /* 0270 */  0xC4, 0x43, 0x02, 0xEE, 0x00, 0x01, 0x67, 0xC2,
                /* 0278 */  0x0F, 0x10, 0xC0, 0xEA, 0xFF, 0x7F, 0x80, 0x80,
                /* 0280 */  0x7B, 0x3F, 0xF0, 0x68, 0xF9, 0x01, 0x02, 0x3C,
                /* 0288 */  0x43, 0xC3, 0x1F, 0x20, 0x00, 0x87, 0x27, 0x00,
                /* 0290 */  0x1F, 0x20, 0x00, 0x57, 0x0A, 0x6D, 0xFA, 0xD4,
                /* 0298 */  0x68, 0xD4, 0xAA, 0x41, 0x99, 0x1A, 0x65, 0x1A,
                /* 02A0 */  0xD4, 0xEA, 0x53, 0xA9, 0x31, 0x63, 0xC7, 0x33,
                /* 02A8 */  0x4B, 0x59, 0xA1, 0xC6, 0xEA, 0x20, 0x20, 0x54,
                /* 02B0 */  0xD0, 0x63, 0x41, 0x46, 0x40, 0xF4, 0xFF, 0x97,
                /* 02B8 */  0x07, 0x22, 0x20, 0x0B, 0xA6, 0x14, 0x90, 0xE5,
                /* 02C0 */  0x83, 0x08, 0xC8, 0xFF, 0x7F                   
            })
        }
    }
}

